#include <math.h>

double getRBConEnergyOPTBasic (
  double tK,
  double bKw,
  double bKh,
  double hL0,
  const double *iniMatTanRB,
  const double *iniMatNorRB,
  const double *iniRefTanRO,
  const double *iniRefNorRO,
  double rtx,
  const double *rotationAnglesRB,
  const double *ex,
  double thetax)
{
  double t1;
  double t10;
  double t102;
  double t105;
  double t107;
  double t109;
  double t111;
  double t114;
  double t116;
  double t117;
  double t118;
  double t12;
  double t120;
  double t122;
  double t124;
  double t130;
  double t134;
  double t14;
  double t140;
  double t144;
  double t150;
  double t156;
  double t157;
  double t159;
  double t16;
  double t161;
  double t166;
  double t173;
  double t178;
  double t18;
  double t187;
  double t190;
  double t198;
  double t2;
  double t20;
  double t201;
  double t211;
  double t217;
  double t22;
  double t227;
  double t23;
  double t234;
  double t236;
  double t238;
  double t24;
  double t241;
  double t242;
  double t244;
  double t254;
  double t257;
  double t264;
  double t270;
  double t277;
  double t283;
  double t292;
  double t3;
  double t30;
  double t301;
  double t31;
  double t37;
  double t38;
  double t4;
  double t46;
  double t5;
  double t51;
  double t53;
  double t56;
  double t6;
  double t61;
  double t64;
  double t65;
  double t66;
  double t67;
  double t68;
  double t69;
  double t70;
  double t71;
  double t73;
  double t74;
  double t75;
  double t76;
  double t78;
  double t79;
  double t8;
  double t81;
  double t82;
  double t86;
  double t87;
  double t9;
  double t90;
  double t92;
  double t93;
  double t95;
  double t98;
  t1 = ex[0];
  t2 = t1 * t1;
  t3 = ex[1];
  t4 = t3 * t3;
  t5 = ex[2];
  t6 = t5 * t5;
  t8 = sqrt(t2 + t4 + t6);
  t9 = 0.1e1 / t8;
  t10 = t9 * t3;
  t12 = iniRefTanRO[0] * t9;
  t14 = 0.1e1 * t12 * t1;
  t16 = iniRefTanRO[1] * t9;
  t18 = 0.1e1 * t16 * t3;
  t20 = iniRefTanRO[2] * t9;
  t22 = 0.1e1 * t20 * t5;
  t23 = t14 + t18 + t22;
  t24 = iniRefNorRO[2];
  t30 = 0.1e1 * t16 * t5 - 0.1e1 * t20 * t3;
  t31 = iniRefNorRO[1];
  t37 = -0.1e1 * t12 * t5 + 0.1e1 * t20 * t1;
  t38 = iniRefNorRO[0];
  t46 = 0.1e1 * t12 * t3 - 0.1e1 * t16 * t1;
  t51 = (t24 * t46 + t30 * t38 + t31 * t37) / (0.1e1 + t14 + t18 + t22);
  t53 = t23 * t24 + t30 * t31 - t37 * t38 + t46 * t51;
  t56 = t9 * t5;
  t61 = t23 * t31 - t24 * t30 + t37 * t51 + t38 * t46;
  t64 = 0.1e1 * t10 * t53 - 0.1e1 * t56 * t61;
  t65 = cos(rtx);
  t66 = rotationAnglesRB[2];
  t67 = cos(t66);
  t68 = rotationAnglesRB[1];
  t69 = cos(t68);
  t70 = t67 * t69;
  t71 = iniMatTanRB[0];
  t73 = sin(t68);
  t74 = t67 * t73;
  t75 = rotationAnglesRB[0];
  t76 = sin(t75);
  t78 = sin(t66);
  t79 = cos(t75);
  t81 = t74 * t76 - t78 * t79;
  t82 = iniMatTanRB[1];
  t86 = t74 * t79 + t76 * t78;
  t87 = iniMatTanRB[2];
  t90 = (t70 * t71 + t81 * t82 + t86 * t87) * t9;
  t92 = 0.1e1 * t90 * t1;
  t93 = t78 * t69;
  t95 = t78 * t73;
  t98 = t67 * t79 + t76 * t95;
  t102 = -t67 * t76 + t79 * t95;
  t105 = (t102 * t87 + t71 * t93 + t82 * t98) * t9;
  t107 = 0.1e1 * t105 * t3;
  t109 = t69 * t76;
  t111 = t69 * t79;
  t114 = (t109 * t82 + t111 * t87 - t71 * t73) * t9;
  t116 = 0.1e1 * t114 * t5;
  t117 = t92 + t107 + t116;
  t118 = iniMatNorRB[0];
  t120 = iniMatNorRB[1];
  t122 = iniMatNorRB[2];
  t124 = t118 * t70 + t120 * t81 + t122 * t86;
  t130 = -0.1e1 * t90 * t5 + 0.1e1 * t114 * t1;
  t134 = t109 * t120 + t111 * t122 - t118 * t73;
  t140 = 0.1e1 * t90 * t3 - 0.1e1 * t105 * t1;
  t144 = t102 * t122 + t118 * t93 + t120 * t98;
  t150 = 0.1e1 * t105 * t5 - 0.1e1 * t114 * t3;
  t156 = 0.1e1 / (0.1e1 + t92 + t107 + t116);
  t157 = (t124 * t150 + t130 * t144 + t134 * t140) * t156;
  t159 = t117 * t124 + t130 * t134 - t140 * t144 + t150 * t157;
  t161 = sin(rtx);
  t166 = t117 * t134 - t124 * t130 + t140 * t157 + t144 * t150;
  t173 = t117 * t144 + t124 * t140 + t130 * t157 - t134 * t150;
  t178 = t9 * t1;
  t187 = (0.1e1 * t178 * t159 + 0.1e1 * t10 * t173 + 0.1e1 * t56 * t166) * (0.1e1 - t65);
  t190 = t65 * t159 + t161 * (0.1e1 * t10 * t166 - 0.1e1 * t56 * t173) + 0.1e1 * t187 * t178;
  t198 = t23 * t38 + t24 * t37 + t30 * t51 - t31 * t46;
  t201 = -0.1e1 * t178 * t53 + 0.1e1 * t56 * t198;
  t211 = t65 * t173 + t161 * (-0.1e1 * t178 * t166 + 0.1e1 * t56 * t159) + 0.1e1 * t187 * t10;
  t217 = 0.1e1 * t178 * t61 - 0.1e1 * t10 * t198;
  t227 = t65 * t166 + t161 * (0.1e1 * t178 * t173 - 0.1e1 * t10 * t159) + 0.1e1 * t187 * t56;
  t234 = atan2(t190 * t64 + t201 * t211 + t217 * t227, t190 * t198 + t211 * t61 + t227 * t53);
  t236 = pow(thetax + rtx - t234, 0.2e1);
  t238 = 0.1e1 / hL0;
  t241 = t156 * t150;
  t242 = cos(thetax);
  t244 = sin(thetax);
  t254 = (0.1e1 * t178 * t198 + 0.1e1 * t10 * t61 + 0.1e1 * t56 * t53) * (0.1e1 - t242);
  t257 = t242 * t53 + t244 * t217 + 0.1e1 * t254 * t56;
  t264 = t242 * t61 + t244 * t201 + 0.1e1 * t254 * t10;
  t270 = t156 * t130;
  t277 = t242 * t198 + t244 * t64 + 0.1e1 * t254 * t178;
  t283 = t156 * t140;
  t292 = pow(0.2e1 * t241 * (0.1e1 * t10 * t257 - 0.1e1 * t56 * t264) + 0.2e1 * t270 * (-0.1e1 * t178 * t257 + 0.1e1 * t56 * t277) + 0.2e1 * t283 * (0.1e1 * t178 * t264 - 0.1e1 * t10 * t277), 0.2e1);
  t301 = pow(-0.2e1 * t241 * t277 - 0.2e1 * t270 * t264 - 0.2e1 * t283 * t257, 0.2e1);
  return(0.5000000000e0 * tK * t236 * t238 + (bKh * t292 + bKw * t301) * t238 / 0.2e1);
}
